#include <cstdio>
#include <vector>
using namespace std;

int n, m, used[1024], mark = 1;
vector<int> v[1024];

void read()
{
    int i, x, y;
    scanf ("%d%d",&n,&m);
    for (i=1; i<=m; i++)
    {
        scanf ("%d%d",&x,&y);
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void dfs(int x)
{
    int i, sz;
    used[x] = mark;
    sz = v[x].size();
    for (i=0; i<sz; i++)
        if (!used[v[x][i]]) dfs(v[x][i]);
}

void solve()
{
    int i, q, x, y;
    for (i=1; i<=n; i++)
    {
        if (!used[i])
        {
            dfs(i);
            mark++;
        }
    }
    scanf ("%d",&q);
    for (i=1; i<=q; i++)
    {
        scanf ("%d%d",&x,&y);
        if (used[x] == used[y]) printf ("1");
        else printf ("0");
    }
    printf ("\n");
}

int main()
{
    read();
    solve();
    return 0;
}
