#include <stdio.h>
#define MAXN 1001

int U[MAXN+1],G[MAXN][MAXN],N,M;
int Q[MAXN],b,e;
void make_empty(){b=0;e=-1;}
void push(int x){Q[++e]=x;}
int pop(){return Q[b++];}
bool is_empty(){return b>e;}

void BFS(int r) {
  int  x,y,i;
   make_empty();push(r);U[r]=r;
  while(!is_empty())
  {  x=pop();
     for(i=1;i<=G[x][0];i++)
     {  y=G[x][i];
        if(!U[y]) {push(y);U[y]=r;}
     }
  }
}

int main()
{
    int i,j,k,R;
    scanf("%d %d",&N,&M);
    for(i=1;i<=N;i++) {G[i][0]=U[0]=0;}
    for(i=1;i<=M;i++)
    {  scanf("%d %d",&j,&k);
       G[j][++G[j][0]]=k;
       G[k][++G[k][0]]=j;
    }
    j=0;
    for(i=1;i<=N;i++)
       if(U[i]==0) {  j++;BFS(i); }
    scanf("%d",&R);
    for(i=1;i<=R;i++)
    {  scanf("%d %d",&j,&k);
       if(U[j]==U[k]) printf("1");
       else printf("0");
    }
    printf("\n");
    return 0;
}
